## org.cybergarage.upnp
Class Service

    java.lang.Object
      org.cybergarage.upnp.Service

    public class Service

extends Object

Field Summary
`static String` `ELEM_NAME`

Constructor Summary
`Service(Node node)`

Method Summary
`void` `addSubscriber(Subscriber sub)`
`void` `announce(String bindAddr)`
`void` `byebye(String bindAddr)`
`void` `clearSID()`
`Action` `getAction(String actionName)`
`ActionList` `getActionList()`
`String` `getControlURL()`
`Device` `getDevice()`
`String` `getEventSubURL()`
`Device` `getRootDevice()`
`byte[]` `getSCPDData()`
`String` `getSCPDURL()`
`String` `getServiceID()`
`Node` `getServiceNode()`
`ServiceStateTable` `getServiceStateTable()`
`String` `getServiceType()`
`String` `getSID()`
`StateVariable` `getStateVariable(String name)`
`Subscriber` `getSubscriber(String name)`
`SubscriberList` `getSubscriberList()`
`long` `getTimeout()`
`boolean` `hasSID()`
`boolean` `hasStateVariable(String name)`
`boolean` `isControlURL(String url)`
`boolean` `isEventSubURL(String url)`
`boolean` `isSCPDURL(String url)`
`boolean` `isService(String name)`
`static boolean` `isServiceNode(Node node)`
`boolean` `isSubscribed()`
`boolean` `loadSCPD(File file)`
`boolean` `loadSCPD(String scpdStr)`
`void` `lock()`
`void` `notify(StateVariable stateVar)`
`void` `notifyAllStateVariables()`
`void` `removeSubscriber(Subscriber sub)`
`boolean` `serviceSearchResponse(SSDPPacket ssdpPacket)`
`void` `setActionListener(ActionListener listener)`
`void` `setControlURL(String value)`
`void` `setEventSubURL(String value)`
`void` `setQueryListener(QueryListener queryListener)`
`void` `setSCPDURL(String value)`
`void` `setServiceID(String value)`
`void` `setServiceType(String value)`
`void` `setSID(String id)`
`void` `setTimeout(long value)`
`void` `unlock()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ELEM_NAME

    public static final String ELEM_NAME

See Also:
  Constant Field Values

Constructor Detail

### Service

    public Service(Node node)

Method Detail

### getServiceNode

    public Node getServiceNode()

### lock

    public void lock()

### unlock

    public void unlock()

### isServiceNode

    public static boolean isServiceNode(Node node)

### getDevice

    public Device getDevice()

### getRootDevice

    public Device getRootDevice()

### setServiceType

    public void setServiceType(String value)

### getServiceType

    public String getServiceType()

### setServiceID

    public void setServiceID(String value)

### getServiceID

    public String getServiceID()

### setSCPDURL

    public void setSCPDURL(String value)

### getSCPDURL

    public String getSCPDURL()

### isSCPDURL

    public boolean isSCPDURL(String url)

### setControlURL

    public void setControlURL(String value)

### getControlURL

    public String getControlURL()

### isControlURL

    public boolean isControlURL(String url)

### setEventSubURL

    public void setEventSubURL(String value)

### getEventSubURL

    public String getEventSubURL()

### isEventSubURL

    public boolean isEventSubURL(String url)

### loadSCPD

    public boolean loadSCPD(String scpdStr)
                     throws InvalidDescriptionException

  Throws:
    `InvalidDescriptionException`

### loadSCPD

    public boolean loadSCPD(File file)
                     throws ParserException

  Throws:
    `ParserException`

### getSCPDData

    public byte[] getSCPDData()

### getActionList

    public ActionList getActionList()

### getAction

    public Action getAction(String actionName)

### getServiceStateTable

    public ServiceStateTable getServiceStateTable()

### getStateVariable

    public StateVariable getStateVariable(String name)

### hasStateVariable

    public boolean hasStateVariable(String name)

### isService

    public boolean isService(String name)

### announce

    public void announce(String bindAddr)

### byebye

    public void byebye(String bindAddr)

### serviceSearchResponse

    public boolean serviceSearchResponse(SSDPPacket ssdpPacket)

### setQueryListener

    public void setQueryListener(QueryListener queryListener)

### getSubscriberList

    public SubscriberList getSubscriberList()

### addSubscriber

    public void addSubscriber(Subscriber sub)

### removeSubscriber

    public void removeSubscriber(Subscriber sub)

### getSubscriber

    public Subscriber getSubscriber(String name)

### notify

    public void notify(StateVariable stateVar)

### notifyAllStateVariables

    public void notifyAllStateVariables()

### getSID

    public String getSID()

### setSID

    public void setSID(String id)

### clearSID

    public void clearSID()

### hasSID

    public boolean hasSID()

### isSubscribed

    public boolean isSubscribed()

### getTimeout

    public long getTimeout()

### setTimeout

    public void setTimeout(long value)

### setActionListener

    public void setActionListener(ActionListener listener)